<?php

//
// This file will be executed only once
if (defined("_ECRIRE_INC_SURLIGNE")) return;
define("_ECRIRE_INC_SURLIGNE", "1");

// used with ob_start() and ob_get_contents() to
// turn the words passed in $var_recherche red
function surligner_mots($page, $mots) {
	global $nombre_surligne;
	include_ecrire("inc_texte.php3"); // to adjust $nombre_surligne

	$accents =
		/* A */ chr(192).chr(193).chr(194).chr(195).chr(196).chr(197).
		/* a */ chr(224).chr(225).chr(226).chr(227).chr(228).chr(229).
		/* O */ chr(210).chr(211).chr(212).chr(213).chr(214).chr(216).
		/* o */ chr(242).chr(243).chr(244).chr(245).chr(246).chr(248).
		/* E */ chr(200).chr(201).chr(202).chr(203).
		/* e */ chr(232).chr(233).chr(234).chr(235).
		/* Cc */ chr(199).chr(231).
		/* I */ chr(204).chr(205).chr(206).chr(207).
		/* i */ chr(236).chr(237).chr(238).chr(239).
		/* U */ chr(217).chr(218).chr(219).chr(220).
		/* u */ chr(249).chr(250).chr(251).chr(252).
		/* yNn */ chr(255).chr(209).chr(241);

	$accents_regexp = array(
		"a" => "[a".chr(224).chr(225).chr(226).chr(227).chr(228).chr(229). chr(192).chr(193).chr(194).chr(195).chr(196).chr(197)."]",
		"o" => "[o".chr(242).chr(243).chr(244).chr(245).chr(246).chr(248). chr(210).chr(211).chr(212).chr(213).chr(214).chr(216)."]",
		"e" => "[e".chr(232).chr(233).chr(234).chr(235). chr(200).chr(201).chr(202).chr(203)."]",
		"c" => "[c".chr(199).chr(231)."]",
		"i" => "[i".chr(236).chr(237).chr(238).chr(239). chr(204).chr(205).chr(206).chr(207)."]",
		"u" => "[u".chr(249).chr(250).chr(251).chr(252). chr(217).chr(218).chr(219).chr(220)."]",
		"y" => "[y".chr(255)."]",
		"n" => "[n".chr(209).chr(241)."]"
	);

	// Replacing characters which could have accents in the search
	// string with the corresponding choices in regexp (!) syntax
	$mots = split("[[:space:]]+", $mots);
	while (list(, $mot) = each ($mots)) {
		if (strlen($mot) > 3) {
			$mot = strtr($mot, $accents, "AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn");
			$mot = strtr(strtolower($mot), $accents_regexp);
			$mots_surligne[] = $mot;
		}
	}

	// not to process what is before </head> or <body>
	$regexp = '/<\/head>|<body[^>]*>/i';
	if (preg_match($regexp, $page, $exp)) {
		$debut = substr($page, 0, strpos($page, $exp[0])+strlen($exp[0]));
		$page = substr($page, strlen($debut));
	} else
		 $debut = '';

	// Replacing a maxi word occurrence with an inter-tag space (max 1 per paragraph, except italics etc.)
	// no more than 4 replacements to avoid strain on CPU
	if ($mots_surligne) {
		$regexp = '/((^|>)([^<]*[^[:alnum:]<])?)(('.join('|', $mots_surligne).')[[:alnum:]]*?)/Uis';
		$page = preg_replace($regexp, '\1<span class="spip_surligne">\4</span>', $page, $nombre_surligne);
	}

	return $debut.$page;
}


// start and finish called from the template
function debut_surligne($mots, $mode_surligne) {

	switch ($mode_surligne) {
		case 'auto' :	// the start of the page is reached, not to touch the buffer
			ob_end_flush();
			ob_start("");
			$mode_surligne = 'actif';
			break;

		case 'actif' :	// there is a buffer to process
			$la_page = surligner_mots(ob_get_contents(), $mots);
			ob_end_clean();
			echo $la_page;
			ob_start("");
			$mode_surligne = 'actif';
			break;

		case 'inactif' :	// there is no buffer
			ob_start("");
			$mode_surligne = 'actif';
			break;

		case false :	// conditions not met (flag_preserver, etc.)
			break;
	}

	return $mode_surligne;
}

function fin_surligne($mots, $mode_surligne) {

	switch ($mode_surligne) {
		case 'auto' :	// coming from the start of the page, dealing with the buffer
			$la_page = surligner_mots(ob_get_contents(), $mots);
			ob_end_clean();
			echo $la_page;
			ob_start("");
			$mode_surligne = 'inactif';
			break;

		case 'actif' :	// there is a buffer to process
			$la_page = surligner_mots(ob_get_contents(), $mots);
			ob_end_clean();
			echo $la_page;
			$mode_surligne = 'inactif';
			break;

		case 'inactif' :	// there is no buffer
			break;

		case false :	// conditions not met (flag_preserver, etc.)
			break;
	}

	return $mode_surligne;
}

?>