<?php

$dir_ecrire = 'ecrire/';
include ("ecrire/inc_version.php3");
include_local ("inc-cache.php3");


//
// Templates inclusions
//

function inclure_fichier($fond, $delais, $contexte_inclus = "") {
	$fichier_requete = $fond;
	if (is_array($contexte_inclus)) {
		reset($contexte_inclus);
		while(list($key, $val) = each($contexte_inclus)) $fichier_requete .= '&'.$key.'='.$val;
	}
	$fichier_cache = generer_nom_fichier_cache($fichier_requete);
	$chemin_cache = "CACHE/".$fichier_cache;

	$use_cache = utiliser_cache($chemin_cache, $delais);

	if (!$use_cache) {
		include_local("inc-calcul.php3");
		$fond = chercher_squelette($fond, $contexte_inclus['id_rubrique']);
		$page = calculer_page($fond, $contexte_inclus);
		if ($page) {
			spip_log("calcul($delais): $chemin_cache");
			ecrire_fichier_cache($chemin_cache, $page);
		}
	}
	return $chemin_cache;
}


//
// Cache management and page calculation
//

$fichier_requete = $REQUEST_URI;
$fichier_requete = strtr($fichier_requete, '?', '&');
$fichier_requete = eregi_replace('&(submit|valider|(var_[^=&]*)|recalcul)=[^&]*', '', $fichier_requete);

$fichier_cache = generer_nom_fichier_cache($fichier_requete);
$chemin_cache = "CACHE/".$fichier_cache;

$use_cache = utiliser_cache($chemin_cache, $delais);

if (!$use_cache OR !defined("_ECRIRE_INC_META_CACHE")) {
	include_ecrire("inc_meta.php3");
}


//
// Authentication
//

if ($HTTP_COOKIE_VARS['spip_session'] OR $PHP_AUTH_USER) {
	include_ecrire ("inc_session.php3");
	verifier_visiteur();
}

//
// Adding a forum
//

if ($ajout_forum) {
	include_local ("inc-forum.php3");
	ajout_forum();
}


if (!$use_cache) {
	$lastmodified = time();
	if (($lastmodified - lire_meta('date_purge_cache')) > 24 * 3600) {
		ecrire_meta('date_purge_cache', $lastmodified);
		$f = fopen('CACHE/.purge', 'w');
		fclose($f);
	}

	//
	// Recalculating cache
	//

	$calculer_cache = true;

	// redirection of article via the deck =http...
	if ($id_article) {
		$query = "SELECT chapo FROM spip_articles WHERE id_article='$id_article'";
		$result = spip_query($query);
		while($row = spip_fetch_array($result)) {
			$chapo = $row['chapo'];
		}
		if (substr($chapo, 0, 1) == '=') {
			include_ecrire('inc_texte.php3');

			$regs = array('','','',substr($chapo, 1));
			list(,$url) = extraire_lien($regs);

			$texte = "<"."?php @header (\"Location: $url\"); ?".">";
			$calculer_cache = false;
			spip_log("redirection: $url");
			ecrire_fichier_cache($chemin_cache, $texte);
		}
	}

	if ($calculer_cache) {
		include_local ("inc-calcul.php3");
		$page = calculer_page_globale($fond);
		if ($page) {
			spip_log("calcul($delais): $chemin_cache");
			ecrire_fichier_cache($chemin_cache, $page);
		}
	}
}


//
// if $var_recherche is positioned, searched words to be in red (php4 only)
//

if ($var_recherche AND $flag_ob AND $flag_preg_replace AND !$flag_preserver AND !$mode_surligne) {
	include_ecrire("inc_surligne.php3");
	$mode_surligne = 'auto';
	ob_start("");
} else {
	unset ($var_recherche);
	unset ($mode_surligne);
}

//
// Cache inclusion to send the page to the client
//

$effacer_cache = !$delais; // $delais can be modified by including a template...

if (!$effacer_cache && !$flag_dynamique && $recalcul != 'oui') {
	if ($lastmodified) {
		@Header ("Last-Modified: ".gmdate("D, d M Y H:i:s", $lastmodified)." GMT");
		@Header ("Expires: ".gmdate("D, d M Y H:i:s", $lastmodified + $delais)." GMT");
	}
}
else {
	@Header("Expires: 0");
	@Header("Cache-Control: no-cache,must-revalidate");
	@Header("Pragma: no-cache");
}

if (file_exists($chemin_cache) && ($HTTP_SERVER_VARS['REQUEST_METHOD'] != 'HEAD')) {
	include ($chemin_cache);
}


//
// concluding words in red
//

if ($var_recherche) {
	fin_surligne($var_recherche, $mode_surligne);
	$timeout = true; // timeout risk
}


//
// cleanses
//

@flush();
if ($effacer_cache) @unlink($chemin_cache);


//
// Verifying the presence of .htaccess in the cache, otherwise generating it
//

if (!file_exists("CACHE/.htaccess")) {
	if ($hebergeur == 'nexenservices'){
		echo "<font color=\"#FF0000\">IMPORTANT : </font>";
		echo "Your host is Nexen Services.<br />";
		echo "Protection of the directory <i>CACHE/</i> must be carried out through ";
		echo "<a href=\"http://www.nexenservices.com/webmestres/htlocal.php\" target=\"_blank\">the webmaster area</a>.";
		echo "Please, create manually the directory protection (a pair of login/password is necessary).<br />";
	}
	else{
		$f = fopen("CACHE/.htaccess", "w");
		fputs($f, "deny from all\n");
		fclose($f);
	}
}


//
// Managing automated indexing
//

if (lire_meta('activer_moteur') == 'oui') {
	$fichier_index = 'ecrire/data/.index';
	if ($db_ok) {
		// include_ecrire("inc_texte.php3");
		// include_ecrire("inc_filtres.php3");
		include_ecrire("inc_index.php3");
		$s = '';
		if ($id_article AND !deja_indexe('article', $id_article))
			$s .= "article $id_article\n";
		if ($id_auteur AND !deja_indexe('auteur', $id_auteur))
			$s .= "auteur $id_auteur\n";
		if ($id_breve AND !deja_indexe('breve', $id_breve))
			$s .= "breve $id_breve\n";
		if ($id_mot AND !deja_indexe('mot', $id_mot))
			$s .= "mot $id_mot\n";
		if ($id_rubrique AND !deja_indexe('rubrique', $id_rubrique))
			$s .= "rubrique $id_rubrique\n";
		if ($s) {
			$f = fopen($fichier_index, 'a');
			fputs($f, $s);
			fclose($f);
		}
	}
	if ($use_cache AND file_exists($fichier_index) AND $size = filesize($fichier_index)) {
		include_ecrire("inc_connect.php3");
		if (!$timeout AND $db_ok) {
			include_ecrire("inc_texte.php3");
			include_ecrire("inc_filtres.php3");
			include_ecrire("inc_index.php3");
			$f = fopen($fichier_index, 'r');
			$s = fgets($f, 100);
			$suite = fread($f, $size);
			fclose($f);
			$f = fopen($fichier_index, 'w');
			fwrite($f, $suite);
			fclose($f);
			$s = explode(' ', trim($s));
			spip_log("indexation $s[0] $s[1]");
			indexer_objet($s[0], $s[1], false);
			$timeout = true;
		}
	}
}


//
// Spring cleaning the cache
// (deleting very old files)
// Triggered once a day when the cache is not refreshed
//

if (!$timeout AND $use_cache AND file_exists('CACHE/.purge2') AND $db_ok) {
	unlink('CACHE/.purge2');
	spip_log("purge cache niveau 2");
	$query = "SELECT fichier FROM spip_forum_cache WHERE maj < DATE_SUB(NOW(), INTERVAL 14 DAY)";
	$result = spip_query($query);
	unset($fichiers);
	while ($row = spip_fetch_array($result)) {
		$fichier = $row['fichier'];
		if (!file_exists("CACHE/$fichier")) $fichiers[] = "'$fichier'";
	}
	if ($fichiers) {
		$query = "DELETE FROM spip_forum_cache WHERE fichier IN (".join(',', $fichiers).")";
		spip_query($query);
	}
	$timeout = true;
}

if (!$timeout AND $use_cache AND file_exists('CACHE/.purge')) {
	unlink('CACHE/.purge');
	spip_log("purge cache niveau 1");
	$f = fopen('CACHE/.purge2', 'w');
	fclose($f);
	include_local ("inc-cache.php3");
	purger_repertoire('CACHE', 14 * 24 * 3600);
	$timeout = true;
}


// ---------------------------------------------------------------------------------------

//
// Administrator features (triggered by the cookie, either authenticated or not)
//

$cookie_admin = $HTTP_COOKIE_VARS['spip_admin'];
$admin_ok = ($cookie_admin != '');

if ($admin_ok AND !$flag_preserver AND !$flag_boutons_admin) {
	include_local("inc-admin.php3");
	afficher_boutons_admin();
}

//
// Updating one (or naught) syndicated site
//

if (!$timeout AND $db_ok AND lire_meta("activer_syndic") != "non") {
	include_ecrire("inc_texte.php3");
	include_ecrire("inc_filtres.php3");
	include_ecrire("inc_sites.php3");
	include_ecrire("inc_index.php3");

	executer_une_syndication();
	executer_une_indexation_syndic();
	$timeout = true;
}

//
// Managing public site statistics
//

if (lire_meta("activer_statistiques") != "non") {
	include_local ("inc-stats.php3");
	ecrire_stats();
}


//
// Sending latest news mail
//

$majnouv = lire_meta('majnouv');
if (!$timeout AND lire_meta('quoi_de_neuf') == 'oui' AND $jours_neuf = lire_meta('jours_neuf')
	AND $adresse_neuf = lire_meta('adresse_neuf') AND (time() - $majnouv) > 3600 * 24 * $jours_neuf) {
	include_ecrire('inc_connect.php3');
	if ($db_ok) {
		// lock && indication of the next dispatch
		include_ecrire('inc_meta.php3');
		lire_metas();	// forcing re-reading the database to avoid concurrent accesses
		if ($majnouv != lire_meta('majnouv')) {
			spip_log("envoi mail nouveautes: acces concurrent");
			exit;
		}

		ecrire_meta('majnouv', time());
		ecrire_metas();

		// mail preparing : reference date in MySQL format for  template's age_relatif (grrr)
		if ($majnouv)
			$date = $majnouv;
		else
			$date = time() - 3600*24*$jours_neuf;
		unset ($mail_nouveautes);
		unset ($sujet_nouveautes);
		$fond = 'nouveautes';
		$delais = 0;
		$contexte_inclus['date'] = date('Y-m-d H:i:s', $date);
		include(inclure_fichier($fond, $delais, $contexte_inclus));

		// sending
		if ($mail_nouveautes) {
			include_ecrire('inc_mail.php3');
			$sujet_nouveautes = filtrer_entites($sujet_nouveautes);
			$mail_nouveautes = filtrer_entites($mail_nouveautes);
			spip_log("envoi mail nouveautes");
			envoyer_mail($adresse_neuf, $sujet_nouveautes, $mail_nouveautes);
		} else
			spip_log("envoi mail nouveautes : pas de nouveautes");
	}
	$timeout = true;
}

?>
